/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
#ifndef HOSTAP_LBF_H
#define HOSTAP_LBF_H

struct lbf_item {
	int bucket;     // between 0 and 1000000 (usec)
	int tokens;     // between 0 and 1000000 (usec)
	float token_rate; 

	// adjust
	int actual;
	int max_buf_len;
	int under_cnt;
	int over_cnt;
};


struct lbf {
	int    firsttime;
	int    use_tftime;
	float  max_token_rate;
	int    index; // points to current queue/sta

	spinlock_t index_lock;
	spinlock_t release_lock;
	struct timeval lastupdate;
	struct timeval lastadjust;
};

struct sta_info;
struct ap_data;

extern void lbf_init(struct lbf *lbf);
extern void lbf_fill_tokens(struct lbf *lbf, struct ap_data *ap);
extern struct sk_buff* lbf_release(struct lbf *lbf, struct ap_data *ap);
extern void lbf_update_tokens(struct lbf *lbf, struct lbf_item *it, 
			      int tftime, struct sta_info* sta, int sent);
extern int lbf_ok_to_release(struct sta_info* sta, int sz, struct ap_data *ap);

extern void lbf_item_init(struct lbf_item *item, struct lbf* lbf);
extern void lbf_adjust_rate(struct lbf *lbf, struct ap_data *ap);

#endif // HOSTAP_LBF_H
